Index: trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/ContainsPatternVisitor.java
===================================================================
--- trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/ContainsPatternVisitor.java	(revision 1152)
+++ trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/ContainsPatternVisitor.java	(revision 1161)
@@ -19,8 +19,6 @@
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ISequence;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePatternVisitor;
-import de.ugoe.cs.autoquest.usability.util.PatternsVisitorUtil;
 
 /**
@@ -49,5 +47,4 @@
     public void visit(IIteration iteration) {
         checkTaskAndReturnIfPatternIsPresent(iteration.getMarkedTask());
-
     }
 
@@ -57,5 +54,4 @@
     public void visit(ISequence sequence) {
         checkAllChildrenAndReturnIfPatternIsPresent(sequence);
-
     }
     
@@ -63,4 +59,5 @@
         for (ITask child : sequence.getChildren()) {
             if(checkTaskAndReturnIfPatternIsPresent(child)) {
+                this.present = true;
                 break;
             }
@@ -69,6 +66,6 @@
     
     private boolean checkTaskAndReturnIfPatternIsPresent(ITask task) {
-        ITaskModel taskModel = PatternsVisitorUtil.createTaskModelFromNode(task);
-        this.present = containedPattern.containedIn(taskModel); 
+        if(isEvent(task)) return false;
+        return this.containedPattern.containedIn(task);
     }
     
Index: trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/EndsWithPatternVisitor.java
===================================================================
--- trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/EndsWithPatternVisitor.java	(revision 1152)
+++ trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/EndsWithPatternVisitor.java	(revision 1161)
@@ -19,5 +19,4 @@
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ISequence;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePatternVisitor;
@@ -48,7 +47,5 @@
      */
     public void visit(IIteration iteration) {
-        ITaskModel taskModel = PatternsVisitorUtil.createTaskModelFromNode(iteration);
-        this.present = containedPattern.containedIn(taskModel); 
-
+        this.present = containedPattern.containedIn(iteration); 
     }
 
@@ -58,11 +55,9 @@
     public void visit(ISequence sequence) {
         ITask lastTask = PatternsVisitorUtil.lastNodeOf(sequence.getChildren());
-        ITaskModel taskModel;
         if(isEvent(lastTask)) {
-            taskModel = PatternsVisitorUtil.createTaskModelFromNode(sequence);
+            this.present = containedPattern.containedIn(sequence);
         } else {
-            taskModel = PatternsVisitorUtil.createTaskModelFromNode(lastTask);
-        }
-        this.present = containedPattern.containedIn(taskModel);      
+            this.present = containedPattern.containedIn(lastTask);
+        }    
     }
 
Index: trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/StartsWithPatternVisitor.java
===================================================================
--- trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/StartsWithPatternVisitor.java	(revision 1152)
+++ trunk/autoquest-core-usability-evaluation/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/StartsWithPatternVisitor.java	(revision 1161)
@@ -19,5 +19,4 @@
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ISequence;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePattern;
 import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePatternVisitor;
@@ -48,6 +47,5 @@
      */
     public void visit(IIteration iteration) {
-        ITaskModel taskModel = PatternsVisitorUtil.createTaskModelFromNode(iteration);
-        this.present = containedPattern.containedIn(taskModel);  
+        this.present = containedPattern.containedIn(iteration);  
     }
 
@@ -57,11 +55,9 @@
     public void visit(ISequence sequence) {
         ITask firstTask = PatternsVisitorUtil.firstNodeOf(sequence.getChildren());
-        ITaskModel taskModel;
         if(isEvent(firstTask)) {
-            taskModel = PatternsVisitorUtil.createTaskModelFromNode(sequence);
+            this.present = containedPattern.containedIn(sequence);
         } else {
-            taskModel = PatternsVisitorUtil.createTaskModelFromNode(firstTask);
-        }
-        this.present = containedPattern.containedIn(taskModel);      
+            this.present = containedPattern.containedIn(firstTask);
+        }    
     }
 