Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/CMDperformUsabilityEvaluationTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/CMDperformUsabilityEvaluationTest.java	(revision 1151)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/CMDperformUsabilityEvaluationTest.java	(revision 1166)
@@ -24,7 +24,7 @@
 import com.google.common.collect.Lists;
 
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTree;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
 import de.ugoe.cs.autoquest.usability.rules.UsabilityResult;
-import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskTreeUtil;
+import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 import de.ugoe.cs.util.console.GlobalDataContainer;
 
@@ -49,6 +49,6 @@
      * Test method for {@link de.ugoe.cs.autoquest.usability.CMDperformUsabilityEvaluation#run(java.util.List)}.
      */
-    public void run_without_evaluation_result_parameter_set_and_no_task_tree_in_data_container() {
-        List<?> parameters = Lists.newArrayList("taskTree");
+    public void run_without_evaluation_result_parameter_set_and_no_task_model_in_data_container() {
+        List<?> parameters = Lists.newArrayList("taskModel");
         new CMDperformUsabilityEvaluation().run((List<Object>) parameters);
         assertThat(getUsabilityEvaluationResult("usabilityEvaluationResult").isPresent()).isFalse();
@@ -64,6 +64,6 @@
      */
     @Test
-    public void run_with_all_parameter_set_and_no_task_tree_in_data_container() {
-        List<?> parameters = Lists.newArrayList("taskTree", "evaluationResult");
+    public void run_with_all_parameter_set_and_no_task_model_in_data_container() {
+        List<?> parameters = Lists.newArrayList("taskModel", "evaluationResult");
         new CMDperformUsabilityEvaluation().run((List<Object>) parameters);
         assertThat(getUsabilityEvaluationResult("evaluationResult").isPresent()).isFalse();
@@ -75,6 +75,6 @@
      */
     @Test
-    public void run_with_more_parameter_set_and_no_task_tree_in_data_container() {
-        List<?> parameters = Lists.newArrayList("taskTree", "evaluationResult", "dummyParameter");
+    public void run_with_more_parameter_set_and_no_task_model_in_data_container() {
+        List<?> parameters = Lists.newArrayList("taskModel", "evaluationResult", "dummyParameter");
         new CMDperformUsabilityEvaluation().run((List<Object>) parameters);
         assertThat(getUsabilityEvaluationResult("evaluationResult").isPresent()).isFalse();
@@ -86,8 +86,10 @@
      */
     @Test
-    public void run_with_all_parameter_set_and_task_tree_in_data_container() {
-        String spec = "EventTask target1 {}";
-        storeInDataContainer(GenerateTaskTreeUtil.getTaskTreeFromSpec(spec));
-        List<?> parameters = Lists.newArrayList("taskTree", "evaluationResult");
+    public void run_with_all_parameter_set_and_task_model_in_data_container() {
+        String spec = "UserSession {" +
+        	      "  Event action1 {}" +
+        	      "}";
+        storeInDataContainer(GenerateTaskModelUtil.getTaskModelFromSpec(spec));
+        List<?> parameters = Lists.newArrayList("taskModel", "evaluationResult");
         new CMDperformUsabilityEvaluation().run((List<Object>) parameters);
         assertThat(getUsabilityEvaluationResult("evaluationResult").isPresent()).isTrue();
@@ -95,6 +97,6 @@
     }
 
-    private void storeInDataContainer(ITaskTree taskTree) {
-        GlobalDataContainer.getInstance().addData("taskTree", taskTree);
+    private void storeInDataContainer(ITaskModel taskModel) {
+        GlobalDataContainer.getInstance().addData("taskModel", taskModel);
     }
     
@@ -105,5 +107,5 @@
     public void print_help_text() {
         String helpText = new CMDperformUsabilityEvaluation().help();
-        assertThat(helpText).isEqualToIgnoringCase("peformUsabilityEvaluation <taskTree> {evaluationResult}");
+        assertThat(helpText).isEqualToIgnoringCase("peformUsabilityEvaluation <taskModel> {evaluationResult}");
     }
 