Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithPatternTest.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithPatternTest.java	(revision 1170)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/rules/patterns/visitors/startswith/StartsWithPatternContainsEventAndEndsWithPatternTest.java	(revision 1205)
@@ -16,4 +16,5 @@
 
 import static de.ugoe.cs.autoquest.usability.tasktree.filters.EventTypeFilter.MOUSE_CLICK;
+import static de.ugoe.cs.autoquest.usability.tasktree.filters.EventTypeFilter.SCROLL;
 import static de.ugoe.cs.autoquest.usability.tasktree.filters.EventTypeFilter.TEXT_INPUT;
 import static de.ugoe.cs.autoquest.usability.tasktree.filters.TaskTypeFilter.SELECTION;
@@ -24,6 +25,6 @@
 
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
-import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePattern;
-import de.ugoe.cs.autoquest.usability.rules.patterns.UsagePatternBuilder;
+import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPattern;
+import de.ugoe.cs.autoquest.usability.rules.patterns.InteractionPatternBuilder;
 import de.ugoe.cs.autoquest.usability.testutil.GenerateTaskModelUtil;
 
@@ -54,25 +55,25 @@
                       "      }" +
                       "    }" +
-                      "  }" +
-                      "  MouseClick target2 {}" +
-                      "  TextInput target3 {}" +
-                      "  Selection sel2 {" +
-                      "    Sequence seq4 {" +
-                      "      TextInput target4 {}" +
-                      "      MouseClick target2 {}" +
+                      "    MouseClick target2 {}" +
+                      "    TextInput target3 {}" +
+                      "    Selection sel2 {" +
+                      "      Sequence seq5 {" +
+                      "        TextInput target4 {}" +
+                      "        MouseClick target2 {}" +
+                      "      }" +
                       "    }" +
-                      "  }" +
-                      "  Selection sel2 {" +
-                      "    Sequence seq5 {" +
-                      "      TextInput target4 {}" +
-                      "      EventTask target2 {}" +
+                      "    Selection sel2 {" +
+                      "      Sequence seq6 {" +
+                      "        TextInput target4 {}" +
+                      "        EventTask target2 {}" +
+                      "      }" +
                       "    }" +
                       "  }" +
                       "}";
         ITaskModel taskTree = GenerateTaskModelUtil.getTaskModelFromSpec(spec);
-        UsagePatternBuilder patternBuilder = new UsagePatternBuilder();
-        UsagePattern startsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
-        UsagePattern endsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
-        UsagePattern pattern = patternBuilder.concernedNode(SEQUENCE).startsWith(startsWithPattern).contains(MOUSE_CLICK).endsWith(endsWithPattern).build();
+        InteractionPatternBuilder patternBuilder = new InteractionPatternBuilder();
+        InteractionPattern startsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
+        InteractionPattern endsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
+        InteractionPattern pattern = patternBuilder.concernedNode(SEQUENCE).startsWith(startsWithPattern).contains(MOUSE_CLICK).endsWith(endsWithPattern).build();
         // When
         boolean patternContained = pattern.containedIn(taskTree);
@@ -89,5 +90,5 @@
                       "      Sequence seq2 {" +
                       "        TextInput target4 {}" +
-                      "        MouseClick target2 {}" +
+                      "        MouseClick target3 {}" +
                       "      }" +
                       "    }" +
@@ -98,25 +99,25 @@
                       "      }" +
                       "    }" +
-                      "  }" +
-                      "  EventTask target2 {}" +
-                      "  TextInput target3 {}" +
-                      "  Selection sel2 {" +
-                      "    Sequence seq4 {" +
-                      "      TextInput target4 {}" +
-                      "      MouseClick target2 {}" +
+                      "    EventTask target2 {}" +
+                      "    TextInput target1 {}" +
+                      "    Selection sel2 {" +
+                      "      Sequence seq5 {" +
+                      "        TextInput target4 {}" +
+                      "        MouseClick target3 {}" +
+                      "      }" +
                       "    }" +
-                      "  }" +
-                      "  Selection sel2 {" +
-                      "    Sequence seq5 {" +
-                      "      TextInput target4 {}" +
-                      "      EventTask target2 {}" +
+                      "    Selection sel2 {" +
+                      "      Sequence seq6 {" +
+                      "        TextInput target4 {}" +
+                      "        EventTask target2 {}" +
+                      "      }" +
                       "    }" +
                       "  }" +
                       "}";
         ITaskModel taskTree = GenerateTaskModelUtil.getTaskModelFromSpec(spec);
-        UsagePatternBuilder patternBuilder = new UsagePatternBuilder();
-        UsagePattern startsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
-        UsagePattern endsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
-        UsagePattern pattern = patternBuilder.concernedNode(SEQUENCE).startsWith(startsWithPattern).contains(MOUSE_CLICK).endsWith(endsWithPattern).build();
+        InteractionPatternBuilder patternBuilder = new InteractionPatternBuilder();
+        InteractionPattern startsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
+        InteractionPattern endsWithPattern = patternBuilder.concernedNode(SELECTION).startsWith(TEXT_INPUT).endsWith(MOUSE_CLICK).build();
+        InteractionPattern pattern = patternBuilder.concernedNode(SEQUENCE).startsWith(startsWithPattern).contains(SCROLL).endsWith(endsWithPattern).build();
         // When
         boolean patternContained = pattern.containedIn(taskTree);