Index: trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRuleTest.java
===================================================================
--- trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRuleTest.java	(revision 927)
+++ trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/TextInputStatisticsRuleTest.java	(revision 1210)
@@ -26,5 +26,4 @@
 
 import de.ugoe.cs.autoquest.usability.UsabilityDefect;
-import de.ugoe.cs.autoquest.usability.UsabilityDefectDescription;
 import de.ugoe.cs.autoquest.usability.UsabilityEvaluationManager;
 
@@ -47,26 +46,16 @@
         // ===== check =====
         String spec =
-            "TextInput (bla) {}";
+            "UserSession {" +
+            "  TextInput (bla) {}" +
+            "}";
         UsabilityDefect[] expectedDefects = new UsabilityDefect[]
             { new UsabilityDefect(HIGH, TEXT_FIELD_INPUT_RATIO) };
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
-
-        // ===== check =====
-        spec =
-            "Sequence {" +
-            "  TextInput (bla) {}" +
-            "}";
-
-        expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, UsabilityDefectDescription.TEXT_FIELD_INPUT_RATIO) };
-
-        assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
-
-        // ===== check =====
-        spec =
-            "Sequence {" +
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
+
+        // ===== check =====
+        spec =
+            "UserSession {" +
             "  TextInput (a) {}" +
             "  TextInput (b) {}" +
@@ -79,9 +68,9 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
-
-        // ===== check =====
-        spec =
-            "Selection {" +
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
+
+        // ===== check =====
+        spec =
+            "UserSession {" +
             "  TextInput (a) {}" +
             "  TextInput (b) {}" +
@@ -94,5 +83,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -106,5 +95,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -173,5 +162,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
     }
 
@@ -198,5 +187,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -214,5 +203,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -229,5 +218,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -245,5 +234,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -326,5 +315,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -407,5 +396,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
     }
 
@@ -455,5 +444,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -494,5 +483,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -533,5 +522,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -572,5 +561,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -590,5 +579,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -608,5 +597,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -626,5 +615,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
     }
@@ -649,5 +638,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -662,5 +651,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -675,5 +664,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
         // ===== check =====
@@ -689,5 +678,5 @@
 
         assertUsabilityEvaluationResult
-            (expectedDefects, manager.evaluateUsability(createTaskTree(spec)));
+            (expectedDefects, manager.evaluateUsability(createTaskModel(spec)));
 
     }