Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/FestConditionUtil.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/FestConditionUtil.java	(revision 1141)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/FestConditionUtil.java	(revision 1218)
@@ -19,6 +19,6 @@
 import com.google.common.base.Optional;
 
-import de.ugoe.cs.autoquest.usability.result.UsabilityDefect;
-import de.ugoe.cs.autoquest.usability.result.UsabilityDefectSeverityLevel;
+import de.ugoe.cs.autoquest.usability.result.UsabilityProblemDescription;
+import de.ugoe.cs.autoquest.usability.result.UsabilityProblemSeverityLevel;
 import de.ugoe.cs.autoquest.usability.rules.UsabilityResult;
 
@@ -41,5 +41,5 @@
             @Override
             public boolean matches(UsabilityResult usabilityResult) {
-                return !usabilityResult.hasDefects();
+                return !usabilityResult.hasDetectedProblems();
             }
         };
@@ -51,14 +51,14 @@
             @Override
             public boolean matches(UsabilityResult usabilityResult) {
-                return usabilityResult.hasDefects();
+                return usabilityResult.hasDetectedProblems();
             }
         };
     }
 
-    public static Condition<Optional<UsabilityDefect>> present() {
-        return new Condition<Optional<UsabilityDefect>>() {
+    public static Condition<Optional<UsabilityProblemDescription>> present() {
+        return new Condition<Optional<UsabilityProblemDescription>>() {
 
             @Override
-            public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
+            public boolean matches(Optional<UsabilityProblemDescription> usabilityGuidlineRecommendation) {
                 return usabilityGuidlineRecommendation.isPresent();
             }
@@ -67,9 +67,9 @@
     }
 
-    public static Condition<Optional<UsabilityDefect>> absent() {
-        return new Condition<Optional<UsabilityDefect>>() {
+    public static Condition<Optional<UsabilityProblemDescription>> absent() {
+        return new Condition<Optional<UsabilityProblemDescription>>() {
 
             @Override
-            public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
+            public boolean matches(Optional<UsabilityProblemDescription> usabilityGuidlineRecommendation) {
                 return !usabilityGuidlineRecommendation.isPresent();
             }
@@ -78,11 +78,11 @@
     }
 
-    public static Condition<Optional<UsabilityDefect>> infoRecommendationSeverityLevel() {
-        return new Condition<Optional<UsabilityDefect>>() {
+    public static Condition<Optional<UsabilityProblemDescription>> infoRecommendationSeverityLevel() {
+        return new Condition<Optional<UsabilityProblemDescription>>() {
 
             @Override
-            public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
+            public boolean matches(Optional<UsabilityProblemDescription> usabilityGuidlineRecommendation) {
                 return usabilityGuidlineRecommendation.get().getSeverityLevel()
-                    .equals(UsabilityDefectSeverityLevel.INFO);
+                    .equals(UsabilityProblemSeverityLevel.INFO);
             }
 
@@ -90,11 +90,11 @@
     }
 
-    public static Condition<Optional<UsabilityDefect>> lowRecommendationSeverityLevel() {
-        return new Condition<Optional<UsabilityDefect>>() {
+    public static Condition<Optional<UsabilityProblemDescription>> lowRecommendationSeverityLevel() {
+        return new Condition<Optional<UsabilityProblemDescription>>() {
 
             @Override
-            public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
+            public boolean matches(Optional<UsabilityProblemDescription> usabilityGuidlineRecommendation) {
                 return usabilityGuidlineRecommendation.get().getSeverityLevel()
-                    .equals(UsabilityDefectSeverityLevel.LOW);
+                    .equals(UsabilityProblemSeverityLevel.LOW);
             }
 
@@ -102,11 +102,11 @@
     }
 
-    public static Condition<Optional<UsabilityDefect>> mediumRecommendationSeverityLevel() {
-        return new Condition<Optional<UsabilityDefect>>() {
+    public static Condition<Optional<UsabilityProblemDescription>> mediumRecommendationSeverityLevel() {
+        return new Condition<Optional<UsabilityProblemDescription>>() {
 
             @Override
-            public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
+            public boolean matches(Optional<UsabilityProblemDescription> usabilityGuidlineRecommendation) {
                 return usabilityGuidlineRecommendation.get().getSeverityLevel()
-                    .equals(UsabilityDefectSeverityLevel.MEDIUM);
+                    .equals(UsabilityProblemSeverityLevel.MEDIUM);
             }
 
@@ -114,11 +114,11 @@
     }
 
-    public static Condition<Optional<UsabilityDefect>> highRecommendationSeverityLevel() {
-        return new Condition<Optional<UsabilityDefect>>() {
+    public static Condition<Optional<UsabilityProblemDescription>> highRecommendationSeverityLevel() {
+        return new Condition<Optional<UsabilityProblemDescription>>() {
 
             @Override
-            public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
+            public boolean matches(Optional<UsabilityProblemDescription> usabilityGuidlineRecommendation) {
                 return usabilityGuidlineRecommendation.get().getSeverityLevel()
-                    .equals(UsabilityDefectSeverityLevel.HIGH);
+                    .equals(UsabilityProblemSeverityLevel.HIGH);
             }
 